xquery version "3.1";

declare namespace exist = "http://exist.sourceforge.net/NS/exist";
declare namespace json = "http://www.json.org";

import module namespace request = "http://exist-db.org/xquery/request";
import module namespace util = "http://exist-db.org/xquery/util";
import module namespace usermanager = "http://exist-db.org/apps/userManager" at "modules/userManager.xqm";
import module namespace jsjson = "http://johnsnelson/json" at "modules/jsjson.xqm";
import module namespace login="http://exist-db.org/xquery/login" at "resource:org/exist/xquery/modules/persistentlogin/login.xql";

import module namespace console="http://exist-db.org/xquery/console";

(:declare namespace output="http://www.w3.org/2010/xslt-xquery-serialization";:)
(:declare option output:method "json";:)
(:declare option output:media-type "application/json";:)



declare variable $exist:user external;
declare variable $exist:controller external;
declare variable $exist:path external;
declare variable $exist:prefix external;


<path match=''>
    <dispatch xmlns="http://exist.sourceforge.net/NS/exist">
        <redirect url="{request:get-uri()}/"/>
    </dispatch>
</path>
<path match="/">
    <dispatch xmlns="http://exist.sourceforge.net/NS/exist">
        <redirect url="index.html"/>
    </dispatch>
</path>
<path match="{$path = 'index.html')}" role="user" xmlns="http://exist.sourceforge.net/NS/exist">
    <dispatch>
        <cache-control cache="yes"/>
    </dispatch>
</path>
<path match="{ends-with($path,'.html')}" role="appuser">
    (: templating html pages :)
</path>
<path match="{starts-with($path,'/restricted')}" role="appmanager">
    <dispatch xmlns="http://exist.sourceforge.net/NS/exist">
        <redirect url="restricted.html"/>
    </dispatch>
</path>
<path match="{request:get-header('x-myheader') = 'foobar'}" role="dba">
{
    (: arbitrary XQuery code here :)
}
</path>
(: list path element does not use a role attribute and is passed through without triggering authentication :)
<path match="{contains($path, 'resources/')}">
    <dispatch xmlns="http://exist.sourceforge.net/NS/exist">
        <cache-control cache="yes"/>
    </dispatch>
</path>






